##
##  grammatica.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2016 OpenPKG Foundation e.V. <http://openpkg.net/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         grammatica
Summary:      Parser Generator for Java and C#
URL:          http://grammatica.percederberg.net/
Vendor:       Per Cederberg
Packager:     OpenPKG Foundation e.V.
Distribution: OpenPKG Community
Class:        EVAL
Group:        CompilerCompiler
License:      LGPL
Version:      1.6
Release:      20160527

#   list of sources
Source0:      http://grammatica.percederberg.net/download/stable/%{version}/grammatica-%{version}.zip
Source1:      grammatica.sh

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, java, JAVA-JDK, ant, infozip
PreReq:       OpenPKG, openpkg >= 20160101, java, JAVA-JDK

%description
    Grammatica is a C# and Java parser generator (compiler compiler).
    It improves upon simlar tools (like yacc and ANTLR) by creating
    well-commented and readable source code, by having automatic error
    recovery and detailed error messages, and by support for testing
    and debugging grammars without generating source code. Grammatica
    supports LL(k) grammars with an unlimited number of look-ahead
    tokens.

%track
    prog grammatica = {
        version   = %{version}
        url       = https://github.com/cederberg/grammatica/releases
        regex     = grammatica-(__VER__)\.zip
    }

%prep
    %setup -q -T -c
    cd ..
    unzip -q -x %{SOURCE0}

%build
    ant compile

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/grammatica
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE grammatica.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/grammatica
    %{l_shtool} install -c -m 644 \
        lib/grammatica-*.jar \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/grammatica/grammatica.jar
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

